package de.intevation.flys.client.server;

import org.w3c.dom.Document;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.server.rpc.RemoteServiceServlet;

import de.intevation.artifacts.common.ArtifactNamespaceContext;
import de.intevation.artifacts.common.utils.ClientProtocolUtils;
import de.intevation.artifacts.common.utils.XMLUtils;

import de.intevation.artifacts.httpclient.exceptions.ConnectionException;
import de.intevation.artifacts.httpclient.http.HttpClient;
import de.intevation.artifacts.httpclient.http.HttpClientImpl;
import de.intevation.artifacts.httpclient.http.response.DocumentResponseHandler;

import de.intevation.flys.client.client.services.CreateCollectionService;


/**
 * This interface provides the createCollection service to create new
 * collections in the artifact server.
 *
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
public class CreateCollectionServiceImpl
extends      RemoteServiceServlet
implements   CreateCollectionService
{
    /** XPath to figure out the uuid of the created collection.*/
    public static final String XPATH_COLLECTION_UUID =
        "/art:result/art:artifact-collection/@art:uuid";


    public String create(String serverUrl, String ownerId) {
        GWT.log("Start creating a new collection.");

        Document create   = ClientProtocolUtils.newCreateDocument(null);
        HttpClient client = new HttpClientImpl(serverUrl);

        try {
            Document doc = (Document) client.createCollection(
                create, ownerId, new DocumentResponseHandler());

            return XMLUtils.xpathString(
                doc, XPATH_COLLECTION_UUID, ArtifactNamespaceContext.INSTANCE);
        }
        catch (ConnectionException ce) {
            System.err.println(ce.getLocalizedMessage());
        }

        return null;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
